blue(N) :- node(N), not red(N), not green(N).
red(N) :- node(N), not blue(N), not green(N).
green(N) :- node(N), not red(N), not blue(N).

:- link(N1,N2), blue(N1), blue(N2).
:- link(N1,N2), red(N1), red(N2).
:- link(N1,N2), green(N1), green(N2).

% constraints learned at 1st UIP, reduced manually:
:- not red(N22),   red(N12),   link(N11, N21), link(N11, N22), link(N21, N22), link(N12, N11), link(N12, N21). 
:- not green(N22), green(N12), link(N11, N21), link(N11, N22), link(N21, N22), link(N12, N11), link(N12, N21). 
:- not blue(N22),  blue(N12),  link(N11, N21), link(N11, N22), link(N21, N22), link(N12, N11), link(N12, N21). 
