blue(N) :- node(N), not red(N), not green(N).
red(N) :- node(N), not blue(N), not green(N).
green(N) :- node(N), not red(N), not blue(N).

:- link(N1,N2), blue(N1), blue(N2).
:- link(N1,N2), red(N1), red(N2).
:- link(N1,N2), green(N1), green(N2).

% CONSTRAINT LEARNED ON 1st UIP:
% one of the original constraints learned at 1st UIP from instance 3col-crafted-chain-00000050.asp:
%:- not red(N22), not _R_("0",(N22)), red(N12), link(N11, N21), node(N11), node(N21), link(N11, N22), link(N21, N22), node(N22), link(N12, N11), link(N12, N21). 
% internal atom replaced:
:- not red(N22), not blue(N22), red(N12), link(N11, N21), node(N11), node(N21), link(N11, N22), link(N21, N22), node(N22), link(N12, N11), link(N12, N21). 
% manually created copies to cover other colour combinations:
:- not red(N22), not green(N22), red(N12), link(N11, N21), node(N11), node(N21), link(N11, N22), link(N21, N22), node(N22), link(N12, N11), link(N12, N21). 
:- not green(N22), not blue(N22), green(N12), link(N11, N21), node(N11), node(N21), link(N11, N22), link(N21, N22), node(N22), link(N12, N11), link(N12, N21). 
:- not green(N22), not red(N22), green(N12), link(N11, N21), node(N11), node(N21), link(N11, N22), link(N21, N22), node(N22), link(N12, N11), link(N12, N21). 
:- not blue(N22), not red(N22), blue(N12), link(N11, N21), node(N11), node(N21), link(N11, N22), link(N21, N22), node(N22), link(N12, N11), link(N12, N21). 
:- not blue(N22), not green(N22), blue(N12), link(N11, N21), node(N11), node(N21), link(N11, N22), link(N21, N22), node(N22), link(N12, N11), link(N12, N21). 
